<?php

/* Liest eine Template Datein ein */
function gettemplate($template){
  global $settings;		
  
$out = implode("",file($settings['loc']."templates/".$template.".".$settings['suffix']));		
return str_replace("\"","\\\"",$out);
}



/* Ersetzt Platzhalter und gibt die Template Datei aus */
function showtemplate($template){
  global $settings;        

  $template = str_replace("{url}", $settings['url'], $template);		
  $template = str_replace("{image_url}", $settings['image_url'], $template);
  $template = str_replace("{thumbsperrow}", $settings['thumbsperrow'], $template);
  $template = str_replace("{titel}", $settings['titel'], $template);
  $template = str_replace("{headline}", $settings['headline'], $template);
  $template = str_replace("{version}", $settings['version'], $template);
  $template = str_replace("{bgcolor}", $settings['bgcolor'], $template);
  $template = str_replace("{bgcolor2}", $settings['bgcolor2'], $template);
  $template = str_replace("{bgcolor3}", $settings['bgcolor3'], $template);
  $template = str_replace("{db_comment}", $settings['db_comment'], $template);
  echo $template;
}

/* Verarbeitet Variablen zum Schutz vor SQL-Injection-Attaken: */
function secure_sql($value){
  if (get_magic_quotes_gpc()) {
    $value = stripslashes($value);
  }
  if (!is_int($value)) {
    $value = "'" . mysql_real_escape_string($value) . "'";
  }
  
  return $value;
}



function prepare4sql($string) {
    
  $string = trim($string);
  $string = strip_tags($string);
  
  $smilies_ort = $settings['url']."gfx";
	$smilies_ubb_array = array(
		":D","biggrin.gif",
		":-D","biggrin.gif",
		"=D","biggrin.gif",
		":d","biggrin.gif",
		":-d","biggrin.gif",
		"=d","biggrin.gif",
		"xD","biggrin.gif",
		"XD","biggrin.gif",
		"xd","biggrin.gif",
		"Xd","biggrin.gif",
		":-[","blush.gif",
		":[","blush.gif",
		":/","blush.gif",
		":-/","blush.gif",
		"=/","blush.gif",
		"8-)","cool.gif",
		"8)","cool.gif",
		"8-d","cool.gif",
		"8-D","cool.gif",
		"8d","cool.gif",
		"8D","cool.gif",
		":-O","eeh.gif",
		":-o","eeh.gif",
		":O","eeh.gif",
		":o","eeh.gif",
		"=o","eeh.gif",
		"=O","eeh.gif",
		":-*","kiss.gif",
		":*","kiss.gif",
		"=*","kiss.gif",
		":-(","sad.gif",
		":(","sad.gif",
		"=(","sad.gif",
		":'(","sad.gif",
		"='(","sad.gif",
		":)","smile.gif",
		":-)","smile.gif",
		"=)","smile.gif",
		":P","tounge.gif",
		":-P","tounge.gif",
		":p","tounge.gif",
		"=p","tounge.gif",
		":9","tounge.gif",
		":-9","tounge.gif",
		"=9","tounge.gif",
		"=P","tounge.gif",
		";)","wink.gif",
		";-)","wink.gif",
		";-D","wink.gif",
		";D","wink.gif",
		";d","wink.gif",
		";d","wink.gif",);    	
  
	$smilie_rep_count = 0;
  while($smilies_ubb_array[$smilie_rep_count] != ""){
  	$smilie_rep_count2 = $smilie_rep_count + 1;
  	$string = str_replace($smilies_ubb_array[$smilie_rep_count], "<img src=\"".$smilies_ort."/".$smilies_ubb_array[$smilie_rep_count2]."\" alt=\"Emotion\" />", $string);
	 	$smilie_rep_count+=2;
  }
  
  $string = eregi_replace("([ \r\n])http://([^ ,\r\n]*)", "\\1[url]http://\\2[/url]", $string);
  $string = eregi_replace("([ \r\n])https://([^ ,\r\n]*)", "\\1[url]https://\\2[/url]", $string);
  $string = eregi_replace("([ \r\n])ftp://([^ ,\r\n]*)", "\\1[url]ftp://\\2[/url]", $string);
  $string = eregi_replace("([ \r\n])www\\.([^ ,\r\n]*)", "\\1[url]http://www.\\2[/url]", $string);
  $string = eregi_replace("^http://([^ ,\r\n]*)", "[url]http://\\1[/url]", $string);
  $string = eregi_replace("^https://([^ ,\r\n]*)", "[url]https://\\1[/url]", $string);
  $string = eregi_replace("^ftp://([^ ,\r\n]*)", "[url]ftp://\\1[/url]", $string);
  $string = eregi_replace("^www\\.([^ ,\r\n]*)", "[url]http://www.\\1[/url]", $string);
  
  $string = str_replace("[hr]", "<hr>", $string); //[hr]
  $string = preg_replace("/\[b\](.*)\[\/b\]/iUms", "<b>\\1</b>", $string); //[b]
  $string = preg_replace("/\[i\](.*)\[\/i\]/iUms", "<i>\\1</i>", $string); //[i]
  $string = preg_replace("/\[s\](.*)\[\/s\]/iUms", "<strike>\\1</strike>", $string); //[s]
  $string = preg_replace("/\[u\](.*)\[\/u\]/iUms", "<u>\\1</u>", $string); //[u]
  $string = preg_replace("/\[email\](.*)\[\/email\]/msiU", "<a href=\"mailto:\\1\" target=\"_blank\">\\1</a>", $string); //[email]
  $string = preg_replace("/\[url\]www.(.*)\[\/url\]/iUms", "<a href=\"http://www.\\1\" target=\"_blank\">http://www.\\1</a>", $string); //[url]
  $string = preg_replace("/\[url\](.*)\[\/url\]/iUms", "<a href=\"\\1\" target=\"_blank\">\\1</a>", $string); //[url]
  $string = preg_replace("/\[url=(.*)\](.*)\[\/url\]/iUms", "<a href=\"\\1\" target=\"_blank\">\\2</a>", $string); //[url=]
  $string = preg_replace("/\[img\](.*)\[\/img\]/iUms", "<div align=\"center\"><img src=\"\\1\" border=\"0\" alt=\"bild\"></div>", $string); //[img]
  $string = preg_replace("/\[green\](.*)\[\/green\]/iUms", "<span style=\"color:green\">\\1</span>", $string); //[green]
  $string = preg_replace("/\[red\](.*)\[\/red\]/iUms", "<span style=\"color:red\">\\1</span>", $string); //[red]
  $string = preg_replace("/\[blue\](.*)\[\/blue\]/iUms", "<span style=\"color:blue\">\\1</span>", $string); //[blue]
  $string = preg_replace("/\[white\](.*)\[\/white\]/iUms", "<span style=\"color:white\">\\1</span>", $string); //[white]
  
  $string = addslashes($string);    
  
  return $string;
}

function prepare4view($string){
  $string = nl2br($string);
  $string = stripslashes($string);
  $new_text = '';
  $string_1 = explode('>',$string);
  $sizeof = sizeof($string_1);
  for ($i=0; $i<$sizeof; ++$i) {
    $string_2 = explode('<',$string_1[$i]);
    if (!empty($string_2[0])) {
      $new_text .= preg_replace('#([^\n\r .]{50})#i', '\\1  ', $string_2[0]);
    }
    if (!empty($string_2[1])) {
      $new_text .= '<' . $string_2[1] . '>';   
    }
  }  
  
  return $new_text;   
}

function prepare4form($string){

  $string = stripslashes($string);
  
  $string = preg_replace("/<b>(.*)<\/b>/iUms", "[b]\\1[/b]", $string); //<b>
	$string = preg_replace("/<i>(.*)<\/i>/iUms", "[i]\\1[/i]", $string); //<i>
	$string = preg_replace("/<u>(.*)<\/u>/iUms", "[u]\\1[/u]", $string); //<u>
	$string = preg_replace("/<strike>(.*)<\/strike>/iUms", "[s]\\1[/s]", $string); //<strike>
	$string = preg_replace("/<a href=\"mailto:(.*)\">(.*)<\/a>/msiU", "[email]\\1[/email]", $string); //<mailto>
	$string = preg_replace("/<a href=\"(.*)\" target=\"_blank\">(.*)<\/a>/iUms","[url=\\1]\\2[/url]", $string); //<a href>
	$string = str_replace("<hr>", "[hr]", $string); //<hr>
	$string = preg_replace("/<div align=\"center\"><img src=\"(.*)\" border=\"0\" alt=\"bild\"><\/div>/iUms", "[img]\\1[/img]", $string); //<img>
	$string = preg_replace("/<span style=\"color:green\">(.*)<\/span>/iUms", "[green]\\1[/green]", $string); //<green>
	$string = preg_replace("/<span style=\"color:red\">(.*)<\/span>/iUms", "[red]\\1[/red]", $string); //<red>
	$string = preg_replace("/<span style=\"color:blue\">(.*)<\/span>/iUms", "[blue]\\1[/blue]" ,$string); //<blue>
	$string = preg_replace("/<span style=\"color:white\">(.*)<\/span>/iUms", "[white]\\1[/white]", $string); //<white>
  
  $smilies_ort = $settings['url']."gfx";
	$smilies_ubb_array = array(
		":D","biggrin.gif",
		":-D","biggrin.gif",
		"=D","biggrin.gif",
		":d","biggrin.gif",
		":-d","biggrin.gif",
		"=d","biggrin.gif",
		"xD","biggrin.gif",
		"XD","biggrin.gif",
		"xd","biggrin.gif",
		"Xd","biggrin.gif",
		":-[","blush.gif",
		":[","blush.gif",
		":/","blush.gif",
		":-/","blush.gif",
		"=/","blush.gif",
		"8-)","cool.gif",
		"8)","cool.gif",
		"8-d","cool.gif",
		"8-D","cool.gif",
		"8d","cool.gif",
		"8D","cool.gif",
		":-O","eeh.gif",
		":-o","eeh.gif",
		":O","eeh.gif",
		":o","eeh.gif",
		"=o","eeh.gif",
		"=O","eeh.gif",
		":-*","kiss.gif",
		":*","kiss.gif",
		"=*","kiss.gif",
		":-(","sad.gif",
		":(","sad.gif",
		"=(","sad.gif",
		":'(","sad.gif",
		"='(","sad.gif",
		":)","smile.gif",
		":-)","smile.gif",
		"=)","smile.gif",
		":P","tounge.gif",
		":-P","tounge.gif",
		":p","tounge.gif",
		"=p","tounge.gif",
		":9","tounge.gif",
		":-9","tounge.gif",
		"=9","tounge.gif",
		"=P","tounge.gif",
		";)","wink.gif",
		";-)","wink.gif",
		";-D","wink.gif",
		";D","wink.gif",
		";d","wink.gif",
		";d","wink.gif",); 
	
  $smilie_rep_count = 0;
  while($smilies_ubb_array[$smilie_rep_count] != ""){
  	$smilie_rep_count2 = $smilie_rep_count + 1;
  	$string = str_replace("<img src=\"".$smilies_ort."/".$smilies_ubb_array[$smilie_rep_count2]."\" alt=\"Emotion\" />", $smilies_ubb_array[$smilie_rep_count], $string);
	 	$smilie_rep_count += 2;
  }
  
  return $string;  
}

/* Liest Bilddateien aus einem Ordner und gibt Dateinamen in einem Array zurueck */
function getImageList($folder){ 
  $handle = opendir($folder); 
  while ($file = readdir($handle)){ 
    if ($file != "." && $file != ".."){    
      $extension = substr(strrchr($file,"."),1);
      $extension = strtolower($extension);
      if($extension == "jpg" || $extension == "jpeg" || $extension == "gif" || $extension == "png"){
        $imageList[] = $file;
      }
    } 
  }
  closedir($handle);
  
  return $imageList;
}



/* Gibt Alles vor dem letzten Vorkommen eines Zeichens zurueck */
function reverse_strrchr($haystack, $needle){
  $pos = strrpos($haystack, $needle);
  if($pos === false){
    return $haystack;
  }
  return substr($haystack, 0, $pos);
}






/* Zip file creation class 
 * makes zip files on the fly... 
 *
 * use the functions add_dir() and add_file() to build the zip file; 
 * see example code below 
 * 
 * by Eric Mueller 
 * [URL]http://www.themepark.com[/URL] 
*/
class zipfile   
{ 
    var $datasec = array(); // array to store compressed data 
    var $ctrl_dir = array(); // central directory    
    var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00"; //end of Central directory record 
    var $old_offset = 0; 

    function add_dir($name)    

    // adds "directory" to archive - do this before putting any files in directory! 
    // $name - name of directory... like this: "path/" 
    // ...then you can add files using add_file with names like "path/file.txt" 
    {   
        $name = str_replace("\\", "/", $name);   

        $fr = "\x50\x4b\x03\x04"; 
        $fr .= "\x0a\x00";    // ver needed to extract 
        $fr .= "\x00\x00";    // gen purpose bit flag 
        $fr .= "\x00\x00";    // compression method 
        $fr .= "\x00\x00\x00\x00"; // last mod time and date 

        $fr .= pack("V",0); // crc32 
        $fr .= pack("V",0); //compressed filesize 
        $fr .= pack("V",0); //uncompressed filesize 
        $fr .= pack("v", strlen($name) ); //length of pathname 
        $fr .= pack("v", 0 ); //extra field length 
        $fr .= $name;   
        // end of "local file header" segment 

        // no "file data" segment for path 

        // "data descriptor" segment (optional but necessary if archive is not served as file) 
        $fr .= pack("V",$crc); //crc32 
        $fr .= pack("V",$c_len); //compressed filesize 
        $fr .= pack("V",$unc_len); //uncompressed filesize 

        // add this entry to array 
        $this -> datasec[] = $fr; 

        $new_offset = strlen(implode("", $this->datasec)); 

        // ext. file attributes mirrors MS-DOS directory attr byte, detailed 
        // at [URL]http://support.microsoft.com/support/kb/articles/Q125/0/19.asp[/URL] 

        // now add to central record 
        $cdrec = "\x50\x4b\x01\x02"; 
        $cdrec .="\x00\x00";    // version made by 
        $cdrec .="\x0a\x00";    // version needed to extract 
        $cdrec .="\x00\x00";    // gen purpose bit flag 
        $cdrec .="\x00\x00";    // compression method 
        $cdrec .="\x00\x00\x00\x00"; // last mod time & date 
        $cdrec .= pack("V",0); // crc32 
        $cdrec .= pack("V",0); //compressed filesize 
        $cdrec .= pack("V",0); //uncompressed filesize 
        $cdrec .= pack("v", strlen($name) ); //length of filename 
        $cdrec .= pack("v", 0 ); //extra field length    
        $cdrec .= pack("v", 0 ); //file comment length 
        $cdrec .= pack("v", 0 ); //disk number start 
        $cdrec .= pack("v", 0 ); //internal file attributes 
        $ext = "\x00\x00\x10\x00"; 
        $ext = "\xff\xff\xff\xff";   
        $cdrec .= pack("V", 16 ); //external file attributes  - 'directory' bit set 

        $cdrec .= pack("V", $this -> old_offset ); //relative offset of local header 
        $this -> old_offset = $new_offset; 

        $cdrec .= $name;   
        // optional extra field, file comment goes here 
        // save to array 
        $this -> ctrl_dir[] = $cdrec;   

          
    } 


    function add_file($data, $name)    

    // adds "file" to archive    
    // $data - file contents 
    // $name - name of file in archive. Add path if your want 

    {   
        $name = str_replace("\\", "/", $name);   
        //$name = str_replace("\\", "\\\\", $name); 

        $fr = "\x50\x4b\x03\x04"; 
        $fr .= "\x14\x00";    // ver needed to extract 
        $fr .= "\x00\x00";    // gen purpose bit flag 
        $fr .= "\x08\x00";    // compression method 
        $fr .= "\x00\x00\x00\x00"; // last mod time and date 

        $unc_len = strlen($data);   
        $crc = crc32($data);   
        $zdata = gzcompress($data);   
        $zdata = substr( substr($zdata, 0, strlen($zdata) - 4), 2); // fix crc bug 
        $c_len = strlen($zdata);   
        $fr .= pack("V",$crc); // crc32 
        $fr .= pack("V",$c_len); //compressed filesize 
        $fr .= pack("V",$unc_len); //uncompressed filesize 
        $fr .= pack("v", strlen($name) ); //length of filename 
        $fr .= pack("v", 0 ); //extra field length 
        $fr .= $name;   
        // end of "local file header" segment 
          
        // "file data" segment 
        $fr .= $zdata;   

        // "data descriptor" segment (optional but necessary if archive is not served as file) 
        $fr .= pack("V",$crc); //crc32 
        $fr .= pack("V",$c_len); //compressed filesize 
        $fr .= pack("V",$unc_len); //uncompressed filesize 

        // add this entry to array 
        $this -> datasec[] = $fr; 

        $new_offset = strlen(implode("", $this->datasec)); 

        // now add to central directory record 
        $cdrec = "\x50\x4b\x01\x02"; 
        $cdrec .="\x00\x00";    // version made by 
        $cdrec .="\x14\x00";    // version needed to extract 
        $cdrec .="\x00\x00";    // gen purpose bit flag 
        $cdrec .="\x08\x00";    // compression method 
        $cdrec .="\x00\x00\x00\x00"; // last mod time & date 
        $cdrec .= pack("V",$crc); // crc32 
        $cdrec .= pack("V",$c_len); //compressed filesize 
        $cdrec .= pack("V",$unc_len); //uncompressed filesize 
        $cdrec .= pack("v", strlen($name) ); //length of filename 
        $cdrec .= pack("v", 0 ); //extra field length    
        $cdrec .= pack("v", 0 ); //file comment length 
        $cdrec .= pack("v", 0 ); //disk number start 
        $cdrec .= pack("v", 0 ); //internal file attributes 
        $cdrec .= pack("V", 32 ); //external file attributes - 'archive' bit set 

        $cdrec .= pack("V", $this -> old_offset ); //relative offset of local header 
//        echo "old offset is ".$this->old_offset.", new offset is $new_offset<br>"; 
        $this -> old_offset = $new_offset; 

        $cdrec .= $name;   
        // optional extra field, file comment goes here 
        // save to central directory 
        $this -> ctrl_dir[] = $cdrec;   
    } 

    function file() { // dump out file    
        $data = implode("", $this -> datasec);   
        $ctrldir = implode("", $this -> ctrl_dir);   

        return    
            $data.   
            $ctrldir.   
            $this -> eof_ctrl_dir.   
            pack("v", sizeof($this -> ctrl_dir)).     // total # of entries "on this disk" 
            pack("v", sizeof($this -> ctrl_dir)).     // total # of entries overall 
            pack("V", strlen($ctrldir)).             // size of central dir 
            pack("V", strlen($data)).                 // offset to start of central dir 
            "\x00\x00";                             // .zip file comment length 
    } 
}
?>